from Products.mxmCounter import mxmCounter


def count(self, obj, REQUEST=None, url_path=None):
    """
    Increases The Count For The Object. It Uses The Physical Path 
    as a key to the count. So it will loose count if object is 
    moved. Tough luck!
    """
    req = obj.REQUEST

    #the patch
    if not url_path:
        url_path = req.URLPATH0


    # try to create unique cookie name
    # I will change it if somebody bitches
    # cookie lasts for a session (pr. browser restart)
    cookie_name = self.meta_type + url_path
    cookie_is_set = req.has_key(cookie_name)
    # if ip is to be ignored, we should only return the value, not 
    # increase it
    ip = req.get('HTTP_X_FORWARDED_FOR', '') or req.get('REMOTE_ADDR', '')
    if (ip and self._ignore_ip(ip)) or (self.count_once and cookie_is_set):
        return self.get_count(obj=obj, REQUEST=req, url_path=url_path)
    else:
        if self.count_once:
            req.response.setCookie(cookie_name, 1)
        return mxmCounter.increase_count(url_path, self.save_interval)

def get_count(self, obj, url_path=None, REQUEST=None):
    "returns the count without incrementing"
    cookie_name = self.meta_type + url_path
    #the patch
    if not url_path:
        url_path = obj.REQUEST.URLPATH0

    count_value = mxmCounter.get_count(url_path)
    if int(count_value)==0:
        obj.REQUEST.RESPONSE.expireCookie(cookie_name, path='/')
        req.response.setCookie(cookie_name, 1)

    return count_value




mxmCounter.mxmCounter.count = count
mxmCounter.mxmCounter.get_count = get_count


